package beans;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import java.lang.Object;
import java.lang.reflect.Field;
/**
 * Servlet  parameter  ٴ
 */
public class ServicePara {

 
 /**
  * properties о´.
  */
  public Properties getProperties() {
    InputStream is = getClass().getResourceAsStream("system.properties");
    Properties sysProps = new Properties();
    try {
      sysProps.load(is);
    }
    catch (Exception e) {
      System.out.println("Can't read the properties file. " +
      "Make sure system.properties is in the CLASSPATH");
      return null;
    }
    return sysProps;
  }

 /**
  * properties  ´.
  */  
  public String getProperty(String s) {
    Properties props = this.getProperties();
    return props.getProperty(s);    
  }

 /**
  * properties Msg ´.
  */  
  public String getMsg(String s) {
    return this.getProperty(s);    
  }

 /**
  * properties SERVLET_DIR ´.
  */  
  public String getServletDir() {
    return getProperty("SERVLET_DIR");
  }
  
 /**
  * properties JSP_DIR ´.
  */    
  public String getJspDir() {
    return getProperty("JSP_DIR");
  }

 /**
  * properties ROOT_DIR ´.
  */    
  public String getRootDir() {
    return getProperty("ROOT_DIR");
  }
  
  /**
	 * request  handlingҶ ʿ
	 */
	private HttpServletRequest req;

	/**
	 * Response  handlingҶ ʿ
	 */
	private HttpServletResponse res;

  /**
   * request Ѵ.
   */
  public HttpServletRequest getRequest() {
    return this.req;
  }

  /**
   * response Ѵ.
   */  
  public HttpServletResponse getResponse() {
    return this.res;
  }
    
	/**
	 * constructor
	 */
	public ServicePara() {
	}
	
	/**
	 * constructor
	 */
	public ServicePara(HttpServletRequest req, HttpServletResponse res) {
		this.req = req;
		this.res = res;
	}

 /**
  * request Parameter ReturnѴ.
  */
	public String getParameter(String s) {
		return req.getParameter(s);
	}

 /**
  * request Object ReturnѴ.
  */
	public Object getAttribute(String s) {
		return req.getAttribute(s);
	}

 /**
  * object requestü ´.
  */
	public void setAttribute(String name, Object obj) {
		req.setAttribute(name, obj);
	}

 /**
  * request   item class ؼ Object ReturnѴ.
  * @param obj :   Object
  * @return : item class Object
  */
  public Object getItems(Object obj) {
  	Class c = obj.getClass();
    Field[] f = c.getFields();

    //logging("f.length="+f.length);

		Enumeration e1 = req.getParameterNames();

		for (Enumeration e = e1 ; e.hasMoreElements() ;) {
			String s = (String)e.nextElement();
    	for (int col = 0; col < f.length; col++) {
				try {
        	if (f[col].getName().equals(s)) {
          	f[col].set(obj,req.getParameter(s));  
          }
        }
        catch (Exception ex) {
        	//logging("ex="+ex);
        }
      }
    }    
		return obj;
	}

 /**
  * ISO-8859-1 String KR String ٲ۴.
  * @param s : ISO-8859-1 String
  * @return : EUC-KR String
  */
  public String toKR(String s) {
    try {
      return new String(s.getBytes("ISO-8859-1"), "EUC-KR");
    }
    catch (UnsupportedEncodingException ex) {
      System.err.print(ex);
      return s;
    }
    catch (Exception ex) {
      System.err.print(ex);
      return s;
    }
  }

 /**
  * KR String ISO-8859-1 String ٲ۴
  * @param s : EUC-KR String
  * @return : ISO-8859-1 String
  */
  public String toISO(String s) {
    try {
      return new String(s.getBytes("EUC-KR"), "ISO-8859-1");
    }
    catch (UnsupportedEncodingException ex) {
      System.err.print(ex);
      return s;
    }
    catch (Exception ex) {
      System.err.print(ex);
      return s;
    }
  }

}
