package beans;

public class SimpleVector
{

    public SimpleVector(int i, int j)
    {
        elementData = new Object[i];
        capacityIncrement = j;
    }

    public SimpleVector(int i)
    {
        this(i, 0);
    }

    public SimpleVector()
    {
        this(10);
    }

    public final int size()
    {
        return elementCount;
    }

    public final synchronized Object elementAt(int i)
    {
        if(i >= elementCount)
            throw new ArrayIndexOutOfBoundsException(i + " >= " + elementCount);
        try
        {
            return elementData[i];
        }
        catch(ArrayIndexOutOfBoundsException ex)
        {
            throw new ArrayIndexOutOfBoundsException(i + " < 0");
        }
    }

    public final synchronized void addElement(Object obj)
    {
        int i = elementCount + 1;
        if(i > elementData.length)
            ensureCapacityHelper(i);
        elementData[elementCount++] = obj;
    }

    public void ensureCapacity(int i)
    {
        if(i > elementData.length)
            ensureCapacityHelper(i);
    }

    private void ensureCapacityHelper(int i)
    {
        int j = elementData.length;
        Object aobj[] = elementData;
        int k = capacityIncrement > 0 ? j + capacityIncrement : j * 2;
        if(k < i)
            k = i;
        elementData = new Object[k];
        System.arraycopy(aobj, 0, elementData, 0, elementCount);
    }

    protected Object elementData[];
    protected int elementCount;
    protected int capacityIncrement;
}

